#include "map.h"
#include "..\VirtualRobot\resource.h"
#include <fstream>
#include <string>
using namespace std;

/////////////////////////////////////////////
//Z̕ǃf[^
/////////////////////////////////////////////
void Map::WriteKabeData(int i,int j,int TORF,unsigned char Hoko)
{
	switch (Hoko){
	case N:
		Cell[i][j].NorthKabe = TORF;
		if(i < 15)
			Cell[i + 1][j].SouthKabe = TORF;
		break;
	case E:
		Cell[i][j].EastKabe = TORF;
		if(j < 15)
			Cell[i][j + 1].WestKabe = TORF;
		break;
	case S:
		Cell[i][j].SouthKabe = TORF;
		if(i > 0)
			Cell[i - 1][j].NorthKabe = TORF;
		break;
	case W:
		Cell[i][j].WestKabe = TORF;
		if(j > 0)
			Cell[i][j - 1].EastKabe = TORF;
		break;
	}
	return;
}
/////////////////////////////////////////////
//f[^ɊÂĕǂ`悷
/////////////////////////////////////////////

void Map::DrawKabe(POINT Point, HDC hdc)
{
    HPEN hPen, hOldPen;
    HBRUSH hBrush, hOldBrush;
	for(int i=0; i<16; i++){
		for(int j=0; j<16; j++){
			DrawKabeOfOneCell(Point, hdc, i, j);
		}
	}
	//S[̏hԂ
	hPen = CreatePen(PS_SOLID, 1, RGB(0, 0, 150));
	hOldPen = (HPEN)SelectObject(hdc, hPen);
	hBrush = CreateSolidBrush(RGB(0,0,150));
	hOldBrush = (HBRUSH)SelectObject(hdc, hBrush);

	Rectangle(hdc,
		Point.x + (CELLHABA - KABEATSUMI) * 7 + KABEATSUMI,
		Point.y + (CELLHABA - KABEATSUMI) * 7 + KABEATSUMI,
		Point.x + (CELLHABA - KABEATSUMI) * 9,
		Point.y + (CELLHABA - KABEATSUMI) * 9);	

	SelectObject(hdc, hOldPen);
	SelectObject(hdc, hOldBrush);
	DeleteObject(hPen);
	DeleteObject(hBrush);
	return;
}
	
//////////////////////////////////////////////////////
//	Z̕ǂ`悷
//////////////////////////////////////////////////////
void Map::DrawKabeOfOneCell(POINT Point, HDC hdc, int cell_i,int cell_j)
{
	POINT CellHidariUe, CellMigiShita;
    HPEN hPen, hOldPen;
	HBRUSH hBrush, hOldBrush;
	CellHidariUe.x = Point.x + (CELLHABA - KABEATSUMI) * cell_j;
	CellHidariUe.y = Point.y + (CELLHABA - KABEATSUMI) * (15 - cell_i);
	CellMigiShita.x = CellHidariUe.x + CELLHABA;
	CellMigiShita.y = CellHidariUe.y + CELLHABA;

	hPen = CreatePen(PS_SOLID, 1, RGB(0, 0, 0));
	hOldPen = (HPEN)SelectObject(hdc, hPen);
	hBrush = CreateSolidBrush(RGB(0,0,0));
	hOldBrush = (HBRUSH)SelectObject(hdc, hBrush);
	SelectObject(hdc,hPen);
	SelectObject(hdc,hBrush);
	Rectangle(hdc, CellHidariUe.x, CellHidariUe.y, CellHidariUe.x + CELLHABA, CellHidariUe.y + CELLHABA);
	SelectObject(hdc, hOldPen);
	SelectObject(hdc, hOldBrush);
	DeleteObject(hPen);
	DeleteObject(hBrush);
	//\
	hPen = CreatePen(PS_SOLID, 1, RGB(255, 0, 0));
	hOldPen = (HPEN)SelectObject(hdc, hPen);
	hBrush = CreateSolidBrush(RGB(255,0,0));
	hOldBrush = (HBRUSH)SelectObject(hdc, hBrush);

	Rectangle(hdc, CellHidariUe.x, CellHidariUe.y, CellHidariUe.x + KABEATSUMI, CellHidariUe.y + KABEATSUMI);
	Rectangle(hdc, CellHidariUe.x, CellHidariUe.y + CELLHABA - KABEATSUMI, CellHidariUe.x + KABEATSUMI, CellHidariUe.y + CELLHABA);	
	Rectangle(hdc, CellHidariUe.x + CELLHABA - KABEATSUMI, CellHidariUe.y, CellHidariUe.x + CELLHABA, CellHidariUe.y + KABEATSUMI);	
	Rectangle(hdc, CellHidariUe.x + CELLHABA - KABEATSUMI, CellHidariUe.y + CELLHABA - KABEATSUMI, CellHidariUe.x + CELLHABA, CellHidariUe.y + CELLHABA);	
	if (Cell[cell_i][cell_j].NorthKabe != False)
		//k̕ǂ\
		Rectangle(hdc, CellHidariUe.x, CellHidariUe.y, CellHidariUe.x + CELLHABA, CellHidariUe.y + KABEATSUMI);	
	if (Cell[cell_i][cell_j].EastKabe != False)
		//̕ǂ\
		Rectangle(hdc, CellHidariUe.x + CELLHABA - KABEATSUMI, CellHidariUe.y, CellHidariUe.x + CELLHABA, CellHidariUe.y + CELLHABA);	
	if (Cell[cell_i][cell_j].SouthKabe != False)
		//̕ǂ\
		Rectangle(hdc, CellHidariUe.x, CellHidariUe.y + CELLHABA - KABEATSUMI, CellHidariUe.x + CELLHABA, CellHidariUe.y + CELLHABA);	
	if (Cell[cell_i][cell_j].WestKabe != False)
		//̕ǂ\
		Rectangle(hdc, CellHidariUe.x, CellHidariUe.y, CellHidariUe.x + KABEATSUMI, CellHidariUe.y + CELLHABA);	
	SelectObject(hdc, hOldPen);
	SelectObject(hdc, hOldBrush);
	DeleteObject(hPen);
	DeleteObject(hBrush);
	return;
}
/////////////////////////////////////////////
//f[^ɊÂĕǂ`悷iv^pj
/////////////////////////////////////////////
void Map::DrawKabeForPrinter(POINT Point, HDC hdc, int w)
{
	for(int i=0; i<16; i++){
		for(int j=0; j<16; j++){
			DrawKabeOfOneCellForPrinter(Point, hdc, i, j ,w);
		}
	}
	return;
}	
//////////////////////////////////////////////////////
//	Z̕ǂ`悷iv^pj
//////////////////////////////////////////////////////
void Map::DrawKabeOfOneCellForPrinter(POINT Point, HDC hdc, int cell_i,int cell_j, int w)
{
	POINT CellHidariUe, CellMigiShita;
    HPEN hPen, hOldPen;
	HBRUSH hBrush, hOldBrush;
	int CELLHABAforPRINTER =  3 * w / 50;
	int KABEATSUMIforPRINTER = CELLHABAforPRINTER / 5;

	CellHidariUe.x = Point.x + (CELLHABAforPRINTER - KABEATSUMIforPRINTER) * cell_j;
	CellHidariUe.y = Point.y + (CELLHABAforPRINTER - KABEATSUMIforPRINTER) * (15 - cell_i);
	CellMigiShita.x = CellHidariUe.x + CELLHABAforPRINTER;
	CellMigiShita.y = CellHidariUe.y + CELLHABAforPRINTER;

	//\
	hPen = CreatePen(PS_SOLID, 1, RGB(0, 0, 0));
	hOldPen = (HPEN)SelectObject(hdc, hPen);
	hBrush = CreateSolidBrush(RGB(0,0,0));
	hOldBrush = (HBRUSH)SelectObject(hdc, hBrush);

	Rectangle(hdc, CellHidariUe.x, CellHidariUe.y, CellHidariUe.x + KABEATSUMIforPRINTER, CellHidariUe.y + KABEATSUMIforPRINTER);
	Rectangle(hdc, CellHidariUe.x, CellHidariUe.y + CELLHABAforPRINTER - KABEATSUMIforPRINTER, CellHidariUe.x + KABEATSUMIforPRINTER, CellHidariUe.y + CELLHABAforPRINTER);	
	Rectangle(hdc, CellHidariUe.x + CELLHABAforPRINTER - KABEATSUMIforPRINTER, CellHidariUe.y, CellHidariUe.x + CELLHABAforPRINTER, CellHidariUe.y + KABEATSUMIforPRINTER);	
	Rectangle(hdc, CellHidariUe.x + CELLHABAforPRINTER - KABEATSUMIforPRINTER, CellHidariUe.y + CELLHABAforPRINTER - KABEATSUMIforPRINTER, CellHidariUe.x + CELLHABAforPRINTER, CellHidariUe.y + CELLHABAforPRINTER);	
	if (Cell[cell_i][cell_j].NorthKabe != False)
		//k̕ǂ\
		Rectangle(hdc, CellHidariUe.x, CellHidariUe.y, CellHidariUe.x + CELLHABAforPRINTER, CellHidariUe.y + KABEATSUMIforPRINTER);	
	if (Cell[cell_i][cell_j].EastKabe != False)
		//̕ǂ\
		Rectangle(hdc, CellHidariUe.x + CELLHABAforPRINTER - KABEATSUMIforPRINTER, CellHidariUe.y, CellHidariUe.x + CELLHABAforPRINTER, CellHidariUe.y + CELLHABAforPRINTER);	
	if (Cell[cell_i][cell_j].SouthKabe != False)
		//̕ǂ\
		Rectangle(hdc, CellHidariUe.x, CellHidariUe.y + CELLHABAforPRINTER - KABEATSUMIforPRINTER, CellHidariUe.x + CELLHABAforPRINTER, CellHidariUe.y + CELLHABAforPRINTER);	
	if (Cell[cell_i][cell_j].WestKabe != False)
		//̕ǂ\
		Rectangle(hdc, CellHidariUe.x, CellHidariUe.y, CellHidariUe.x + KABEATSUMIforPRINTER, CellHidariUe.y + CELLHABAforPRINTER);	
	SelectObject(hdc, hOldPen);
	SelectObject(hdc, hOldBrush);
	DeleteObject(hPen);
	DeleteObject(hBrush);
	return;
}
/////////////////////////////////////////////
//f[^ɊÂă{bg`悷
/////////////////////////////////////////////

//{bg̕`̓rbg}bṽ[hōs

void Map::DrawRobot(POINT Point, HWND hWnd,HDC hdc)
{

	POINT CellHidariUe;

	CellHidariUe.x = Point.x + (CELLHABA - KABEATSUMI) * Ichi.cell_j;	//{bgZ̍̍W
	CellHidariUe.y = Point.y + (CELLHABA - KABEATSUMI) * (15 - Ichi.cell_i);

    HDC hmdc;
    HBITMAP hBitmap1,hBitmap2;
    BITMAP bmp;
    HINSTANCE hInst;
    int BMP_W, BMP_H;

    hInst = (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);
	switch(Muki){
	case N:
		hBitmap1 = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_MOUSE_N_AND));
		hBitmap2 = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_MOUSE_N));
		break;
	case E:
		hBitmap1 = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_MOUSE_E_AND));
		hBitmap2 = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_MOUSE_E));
		break;
	case S:
		hBitmap1 = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_MOUSE_S_AND));
		hBitmap2 = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_MOUSE_S));
		break;
	case W:
		hBitmap1 = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_MOUSE_W_AND));
		hBitmap2 = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_MOUSE_W));
		break;
	}
	GetObject(hBitmap1, sizeof(BITMAP), &bmp);
    BMP_W = (int)bmp.bmWidth;
    BMP_H = (int)bmp.bmHeight;
    hmdc = CreateCompatibleDC(hdc);
    SelectObject(hmdc, hBitmap1);
    BitBlt(hdc, CellHidariUe.x, CellHidariUe.y, BMP_W, BMP_H, hmdc, 0, 0, SRCAND);
	GetObject(hBitmap2, sizeof(BITMAP), &bmp);
    SelectObject(hmdc, hBitmap2);
    BitBlt(hdc, CellHidariUe.x, CellHidariUe.y, BMP_W, BMP_H, hmdc, 0, 0, SRCPAINT);
    DeleteDC(hmdc);
    DeleteObject(hBitmap1);
    DeleteObject(hBitmap2);
    return;
}
void Map::HideRobot(POINT Point, HWND hWnd,HDC hdc)	//{bgB
{

	POINT CellHidariUe;

	CellHidariUe.x = Point.x + (CELLHABA - KABEATSUMI) * Ichi_mem.cell_j;	//{bgZ̍̍W
	CellHidariUe.y = Point.y + (CELLHABA - KABEATSUMI) * (15 - Ichi_mem.cell_i);

    HDC hmdc;
    HBITMAP hBitmap1;
    BITMAP bmp;
    HINSTANCE hInst;
    int BMP_W, BMP_H;

    hInst = (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);
	switch(Muki_mem){
	case N:
		hBitmap1 = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_MOUSE_N_AND));
		break;
	case E:
		hBitmap1 = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_MOUSE_E_AND));
		break;
	case S:
		hBitmap1 = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_MOUSE_S_AND));
		break;
	case W:
		hBitmap1 = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_MOUSE_W_AND));
		break;
	}
	GetObject(hBitmap1, sizeof(BITMAP), &bmp);
    BMP_W = (int)bmp.bmWidth;
    BMP_H = (int)bmp.bmHeight;
    hmdc = CreateCompatibleDC(hdc);
    SelectObject(hmdc, hBitmap1);
    BitBlt(hdc, CellHidariUe.x, CellHidariUe.y, BMP_W, BMP_H, hmdc, 0, 0, SRCAND);
    DeleteDC(hmdc);
    DeleteObject(hBitmap1);
    return;
}

//i܂jwi`悷

void Map::DrawHaikei(POINT Point, HWND hWnd,HDC hdc)
{

	POINT CellHidariUe;

	CellHidariUe.x = 0;	//{bgZ̍̍W
	CellHidariUe.y = 0;

    HDC hmdc;
    HBITMAP hBitmap;
    BITMAP bmp;
    HINSTANCE hInst;
    int BMP_W, BMP_H;
	RECT rt;
    hInst = (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);
	hBitmap = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_TEST));
	GetObject(hBitmap, sizeof(BITMAP), &bmp);
    BMP_W = (int)bmp.bmWidth;
    BMP_H = (int)bmp.bmHeight;
    hmdc = CreateCompatibleDC(hdc);
    SelectObject(hmdc, hBitmap);
	GetClientRect(hWnd, &rt);	//NCAg̈̑傫߂
    StretchBlt(hdc,rt.left, rt.top, rt.right, rt.bottom,hmdc, 0, 0, BMP_W, BMP_H, SRCCOPY); 
    DeleteDC(hmdc);
    DeleteObject(hBitmap);
    return;
}
///////////////////////////////////////////////////
//ǃf[^t@CitpXjǂݍ
///////////////////////////////////////////////////
int Map::ReadFileKabeData(char *lpstrfile)
{
	FILE *stream;
	int i,j,buf;
	if(lpstrfile[0] == 0) return 1;	//t@CȂfopenreturniLZKvj
	stream = fopen(lpstrfile, "r" );
	if( stream == NULL )
		return 1;	//G[̂Ƃ1Ԃ
	else{
			while(!feof(stream)){
				fscanf( stream, "%d,", &i );	fflush(stdin);
				fscanf( stream, "%d,", &j );	fflush(stdin);
				fscanf( stream, "%d,", &buf);	fflush(stdin);
				WriteKabeData(i, j, buf, N);
				fscanf( stream, "%d,", &buf);	fflush(stdin);
				WriteKabeData(i, j, buf, E);
				fscanf( stream, "%d,", &buf);	fflush(stdin);
				WriteKabeData(i, j, buf, S);
				fscanf( stream, "%d\n", &buf);	fflush(stdin);
				WriteKabeData(i, j, buf, W);
			}
		fclose( stream );
		return 0;	//ɏIƂ0Ԃ
	}
	return 0;
}
int Map::WriteFileKabeData(char *lpstrfile)	//ǃf[^t@Cɕۑ
{
	ofstream ofile(lpstrfile);	//t@CJ
	if(!ofile) return 1;
	for(int i=0; i<16; i++){
		for(int j=0; j<16; j++){
			ofile << i << ',';
			ofile << j << ',';
			ofile << (int)Cell[i][j].NorthKabe << ',' ;
			ofile << (int)Cell[i][j].EastKabe << ',' ;
			ofile << (int)Cell[i][j].SouthKabe << ',' ;
			ofile << (int)Cell[i][j].WestKabe << endl;
		}
	}
	ofile.close();
	return 0;
}

///////////////////////////////////////////////////
//{bgf[^󂯎
///////////////////////////////////////////////////
void Map::ReceiveDataFromRobot(int Robot_Command)	
{
	Muki_mem = Muki;
	Ichi_mem = Ichi;
	switch(Robot_Command){
	case TURN_NON:	break;
	case TURN_R:
		Muki = (Muki + 1) % 4;	break;
	case TURN_U:
		Muki = (Muki + 2) % 4;	break;
	case TURN_L:
		Muki = (Muki + 3) % 4;	break;
	case ZENSHIN:	break;
	case TURN_R_ONLY:
		Muki = (Muki + 1) % 4;	return;
	case TURN_U_ONLY:
		Muki = (Muki + 2) % 4;	return;
	case TURN_L_ONLY:
		Muki = (Muki + 3) % 4;	return;
	}
	switch(Muki){
	case N:
		if(Ichi.cell_i<15){Ichi.cell_i++;}	break;
	case E:
		if(Ichi.cell_j<15){Ichi.cell_j++;}	break;
	case S:
		if(Ichi.cell_i>0){Ichi.cell_i--;}	break;
	case W:
		if(Ichi.cell_j>0){Ichi.cell_j--;}	break;
	}
	return;
}
////////////////////////////////////////////////////
//Zf[^iׂĂ̕ǂFalsej
////////////////////////////////////////////////////
void Map::ResetMap()
{
	for(int i=0;i<=15;i++){
		for(int j=0;j<=15;j++){
			Cell[i][j].NorthKabe = False;
			Cell[i][j].EastKabe = False;
			Cell[i][j].SouthKabe = False;
			Cell[i][j].WestKabe = False;
		}
	}
}
/////////////////////////////////////////////////////
//͂߂猈܂Ăǂ֐
/////////////////////////////////////////////////////
void Map::InitMap()
{	
	//Ogɂ͕Kǂ
	for(int i=0;i<16;i++){		
		Cell[i][0].WestKabe = True;
		Cell[i][15].EastKabe = True;
		Cell[0][i].SouthKabe = True;
		Cell[15][i].NorthKabe = True;
	}
	//S[ɂ͕ǂȂ
	Cell[8][7].EastKabe = False;
	Cell[8][7].SouthKabe = False;
	Cell[8][8].WestKabe = False;
	Cell[8][8].SouthKabe = False;
	Cell[7][7].EastKabe = False;
	Cell[7][7].NorthKabe = False;
	Cell[7][8].WestKabe = False;
	Cell[7][8].NorthKabe = False;
	//X^[g̓ɂ͕Kǂ
	Cell[0][0].EastKabe = True;
	Cell[0][1].WestKabe = True;
	//X^[g̖kɂ͕ǂȂ
	Cell[0][0].NorthKabe = False;
	Cell[1][0].SouthKabe = False;
	return;
}
/////////////////////////////////////////
//{bg̈ʒuƌ
/////////////////////////////////////////
void Map::ResetRobo()
{
	//{bg̈ʒu
	Ichi.cell_i = 0;
	Ichi.cell_j = 0;
	Ichi_mem.cell_i = 0;
	Ichi_mem.cell_j = 0;
	//{bǧ
	Muki = N;
	Muki_mem = N;
}
/////////////////////////////////////////
//{bg̈ʒuf[^ǂ
/////////////////////////////////////////
ichi Map::ReadIchi()
{
	return Ichi;
}
/////////////////////////////////////////
//{bg̈ʒuf[^ǂ
/////////////////////////////////////////
ichi Map::ReadIchi_mem()
{
	return Ichi_mem;
}
/////////////////////////////////////////
//{bǧf[^ǂ
/////////////////////////////////////////
unsigned char Map::ReadMuki()
{
	return Muki;
}
/////////////////////////////////////////
//{bǧf[^ǂ
/////////////////////////////////////////
unsigned char Map::ReadMuki_mem()
{
	return Muki_mem;
}
