#include "robotmap.h"

RobotMap::RobotMap(void){
	for(int i = 0; i < 16; i++){
		for(int j = 0; j < 16; j++){
			int I,J;
			Cell[i][j].Omomi = Cell[i][j].Kitakaisu = Cell[i][j].SaitanMap = 0;
			Cell[i][j].KasoEastKabe = Cell[i][j].KasoNorthKabe = Cell[i][j].KasoSouthKabe = Cell[i][j].KasoWestKabe = False;
			if (i >= 7) I = 15 - i; else I = i;	//Sd݃f[^̌vZispjƃZbg
			if (j >= 7) J = 15 - j; else J = j;
			Cell[i][j].KyushinOmomi = I + J;
		}
	}
	Cell[0][0].Kitakaisu = 1;	//X^[gn_̗񐔂Pɂ
	GenzaiHosuu = GoalHosuu = 0;	//݂̕ES[
	OuFuku = 0;		//HF0@HF1
	Start = 1;	//X^[gȂ̂ŃtO
}
////////////////////////////////////////////////
//ef[^ނƂ̊֐
////////////////////////////////////////////////
void RobotMap::WriteKaisuData(int i,int j,int KaisuData)
{
	Cell[i][j].Kitakaisu = KaisuData;
}

void RobotMap::WriteOmomiData(int i,int j,int OmomiData)
{
	Cell[i][j].Omomi = OmomiData;
}

void RobotMap::WriteKyushinOmomiData(int i,int j,int KyushinOmomiData)	//̃Z̋Sd݂
{
	Cell[i][j].KyushinOmomi = KyushinOmomiData;
}

void RobotMap::WriteTsugiKensa(int i,int j,int TsugiData)
{
	Cell[i][j].TsugiKensa = TsugiData;
}

void RobotMap::WriteOuFuku(int oufuku)
{
	OuFuku = oufuku;
}

void RobotMap::WriteStartOrNot(int startornot)
{
	Start = startornot;
}

////////////////////////////////////////////////
//ef[^Zbg֐
////////////////////////////////////////////////
void RobotMap::ResetKasoKabe()
{
	//Zf[^iׂẲzǂFalsejAŒZoH}bv
	for(int i=0;i<=15;i++){
		for(int j=0;j<=15;j++){
			Cell[i][j].KasoNorthKabe = False;
			Cell[i][j].KasoEastKabe = False;
			Cell[i][j].KasoSouthKabe = False;
			Cell[i][j].KasoWestKabe = False;
			Cell[i][j].SaitanMap = 0;
		}
	}
	return;
}

void RobotMap::ResetRobo()
{
	//{bg̈ʒu
	Ichi.cell_i = 0;
	Ichi.cell_j = 0;
	//{bǧ
	Muki = N;
	for(int i = 0; i < 16; i++){
		for(int j = 0; j < 16; j++){
			Cell[i][j].Omomi = Cell[i][j].Kitakaisu = Cell[i][j].SaitanMap = 0;
			Cell[i][j].TsugiKensa = 0;	//ŒZoHT̎ɂɒׂZ\tO
		}
	}
	Cell[0][0].Kitakaisu = 1;
	GenzaiHosuu = 0;	//݂̕
}

void RobotMap::ResetKyushinOmomi()	//Sd݃f[^
{
	int I,J;
	for(int i = 0; i < 16; i++){
		for(int j = 0; j < 16; j++){
			if (i >= 7) I = 15 - i; else I = i;
			if (j >= 7) J = 15 - j; else J = j;
			Cell[i][j].KyushinOmomi = I + J;
		}
	}
}
/////////////////////////////////////////////////
//Ẑ܂Ȃɗ񐔃f[^\
/////////////////////////////////////////////////
void RobotMap::DrawKaisuOnCell(POINT Point, HDC hdc)	
{
	char moji[4];
	POINT CellHidariUe;
	int oldBkMode = GetBkMode(hdc);
	int oldTextColor = GetTextColor(hdc);
	SetBkMode(hdc, TRANSPARENT);
	SetTextColor(hdc, RGB(0, 255, 255));
	for(int i = 0;i < 16; i ++){
		for(int j = 0;j < 16; j ++){
			CellHidariUe.x = Point.x + (CELLHABA - KABEATSUMI) * j;
			CellHidariUe.y = Point.y + (CELLHABA - KABEATSUMI) * (15 - i);
			int k = Cell[i][j].Kitakaisu;
			if(k > 0){
				sprintf(moji,"%2d", Cell[i][j].Kitakaisu);
				TextOut(hdc,CellHidariUe.x + 8,CellHidariUe.y+ 8,moji,2);
			}
		}
	}
	SetBkMode(hdc, oldBkMode);
	SetTextColor(hdc, oldTextColor);
}
/////////////////////////////////////////////////
//Z̐^ɏd݃f[^\
/////////////////////////////////////////////////
void RobotMap::DrawOmomiOnCell(POINT Point, HDC hdc)	
{
	char moji[3];
	POINT CellHidariUe;
	int oldBkMode = GetBkMode(hdc);
	int oldTextColor = GetTextColor(hdc);
	SetBkMode(hdc, TRANSPARENT);
	SetTextColor(hdc, RGB(0, 255, 255));
	for(int i = 0;i < 16; i ++){
		for(int j = 0;j < 16; j ++){
			CellHidariUe.x = Point.x + (CELLHABA - KABEATSUMI) * j;
			CellHidariUe.y = Point.y + (CELLHABA - KABEATSUMI) * (15 - i);
			int k = Cell[i][j].Omomi;
			if(k > 0){
				sprintf(moji,"%2d",k);
				TextOut(hdc,CellHidariUe.x + 8,CellHidariUe.y + 8,moji,2);
			}
		}
	}
	SetBkMode(hdc, oldBkMode);
	SetTextColor(hdc, oldTextColor);
}
//////////////////////////////////////
//݂̕\
//////////////////////////////////////
void RobotMap::DrawGenzaiHosuu(POINT Point, HDC hdc)
{
	char moji[30];
	POINT HidariUe;
	HidariUe.x = 10;
	HidariUe.y = Point.y + (CELLHABA - KABEATSUMI) * 16 + 10;
	int i = sprintf(moji,"                             ");
	TextOut(hdc,HidariUe.x,HidariUe.y,moji,i);
	i = sprintf(moji,"݂̕F%3d",GenzaiHosuu);
	TextOut(hdc,HidariUe.x,HidariUe.y,moji,i);
	GenzaiHosuu ++;	//Ă΂邽т1₷

}
//////////////////////////////////////
//S[̕ێ
//////////////////////////////////////
void RobotMap::HojiGoalHosuu()
{
	GoalHosuu = GenzaiHosuu;
}
//////////////////////////////////////
//S[̕\
//////////////////////////////////////
void RobotMap::DrawGoalHosuu(POINT Point, HDC hdc)
{
	char moji[30];
	POINT HidariUe;
	HidariUe.x = 200;
	HidariUe.y = Point.y + (CELLHABA - KABEATSUMI) * 16 + 10;
	int i = sprintf(moji,"%3dŃS[܂I",GoalHosuu);
	TextOut(hdc,HidariUe.x,HidariUe.y,moji,i);
}
///////////////////////////////////////////////////////
//X^[gɖ߂Ă̕ێ
///////////////////////////////////////////////////////
void RobotMap::HojiReturnHosuu()
{
	ReturnHosuu = GenzaiHosuu;
}
///////////////////////////////////////////////////////
//S[̕
///////////////////////////////////////////////////////
void RobotMap::DrawReturnHosuu(POINT Point, HDC hdc)
{
	char moji[30];
	POINT HidariUe;
	HidariUe.x = 400;
	HidariUe.y = Point.y + (CELLHABA - KABEATSUMI) * 16 + 10;
	int i = sprintf(moji,"%3dŋA҂܂I",ReturnHosuu);
	TextOut(hdc,HidariUe.x,HidariUe.y,moji,i);
}

///////////////////////////////////////////////////////
//S[EX^[gAҎ̕Ȃ
///////////////////////////////////////////////////////
void RobotMap::EraseGoalReturnHosuu(POINT Point, HDC hdc)
{
	char moji[30];
	POINT HidariUe;
	HidariUe.x = 200;
	HidariUe.y = Point.y + (CELLHABA - KABEATSUMI) * 16 + 10;
	int i = sprintf(moji,"                             ");
	TextOut(hdc,HidariUe.x,HidariUe.y,moji,i);
	HidariUe.x = 400;
	SetBkMode(hdc, OPAQUE);
//	SetTextColor(hdc, RGB(255, 255, 255));
	TextOut(hdc,HidariUe.x,HidariUe.y,moji,i);
}

/////////////////////////////////////////////////////
//zǂ\
/////////////////////////////////////////////////////
void RobotMap::DrawKasoKabe(POINT Point, HDC hdc)
{
	POINT CellHidariUe, CellMigiShita;
    HPEN hPen, hOldPen;
    HBRUSH hBrush, hOldBrush;

	hPen = CreatePen(PS_SOLID, 1, RGB(0, 0, 0));
	hOldPen = (HPEN)SelectObject(hdc, hPen);
	hBrush = CreateSolidBrush(RGB(0,255,0));
	hOldBrush = (HBRUSH)SelectObject(hdc, hBrush);
	SelectObject(hdc,hPen);
	SelectObject(hdc,hBrush);
	for(int i=0; i<16; i++){
		for(int j=0; j<16; j++){
			CellHidariUe.x = Point.x + (CELLHABA - KABEATSUMI) * j;
			CellHidariUe.y = Point.y + (CELLHABA - KABEATSUMI) * (15 - i);
			CellMigiShita.x = CellHidariUe.x + CELLHABA;
			CellMigiShita.y = CellHidariUe.y + CELLHABA;
			if (Cell[i][j].KasoNorthKabe == True)
				//k̉zǂ\
				Rectangle(hdc, CellHidariUe.x, CellHidariUe.y, CellHidariUe.x + CELLHABA, CellHidariUe.y + KABEATSUMI);	
			if (Cell[i][j].KasoEastKabe == True)
				//̉zǂ\
				Rectangle(hdc, CellHidariUe.x + CELLHABA - KABEATSUMI, CellHidariUe.y, CellHidariUe.x + CELLHABA, CellHidariUe.y + CELLHABA);	
			if (Cell[i][j].KasoSouthKabe == True)
				//̉zǂ\
				Rectangle(hdc, CellHidariUe.x, CellHidariUe.y + CELLHABA - KABEATSUMI, CellHidariUe.x + CELLHABA, CellHidariUe.y + CELLHABA);	
			if (Cell[i][j].KasoWestKabe == True)
				//̉zǂ\
				Rectangle(hdc, CellHidariUe.x, CellHidariUe.y, CellHidariUe.x + KABEATSUMI, CellHidariUe.y + CELLHABA);	
		}
	}
	SelectObject(hdc, hOldPen);
	SelectObject(hdc, hOldBrush);
	DeleteObject(hPen);
	DeleteObject(hBrush);

}

/////////////////////////////////////////////////////
//zǃf[^
/////////////////////////////////////////////////////
void RobotMap::WriteKasoKabeData(int i,int j,int TORF,unsigned char Hoko)
{
	switch (Hoko){
	case N:
		Cell[i][j].KasoNorthKabe = TORF;
		if(i < 15)
			Cell[i + 1][j].KasoSouthKabe = TORF;
		break;
	case E:
		Cell[i][j].KasoEastKabe = TORF;
		if(j < 15)
			Cell[i][j + 1].KasoWestKabe = TORF;
		break;
	case S:
		Cell[i][j].KasoSouthKabe = TORF;
		if(i > 0)
			Cell[i - 1][j].KasoNorthKabe = TORF;
		break;
	case W:
		Cell[i][j].KasoWestKabe = TORF;
		if(j > 0)
			Cell[i][j - 1].KasoEastKabe = TORF;
		break;
	}
	return;
}
/////////////////////////////////////////////////////
//zǃf[^ǂݍ
/////////////////////////////////////////////////////
int RobotMap::ReadKukakuKasoKabeData(int Hoko)
{
	int i = (ReadIchi()).cell_i;
	int j = (ReadIchi()).cell_j;
	int k = (ReadMuki() + Hoko) % 4;
	if(k == N) return(Cell[i][j].KasoNorthKabe);
	else if(k == E) return(Cell[i][j].KasoEastKabe);
	else if(k == S) return(Cell[i][j].KasoSouthKabe);
	else return(Cell[i][j].KasoWestKabe);
	return 1;
}
/////////////////////////////////////////////////////
//Z̃f[^ǂݏo
/////////////////////////////////////////////////////
robotcell RobotMap::ReadRobotCellData(int i,int j)
{
	return Cell[i][j]; 
}
///////////////////////////////////////////////////////
//܂łɂ킩ĂHf[^ƂɂāAŒZoH
//߂邽߂́ud݁v̌vZisƂȂƂɂ͂ȂƂɂj
///////////////////////////////////////////////////////
void RobotMap::KeisanOmomi(void)	
{
	int i,j;
	//d݃f[^
	for(i = 0; i < 16; i++){
		for(j = 0; j < 16; j++){
			WriteOmomiData(i, j, 0);
			WriteTsugiKensa(i, j, 0);
		}
	}
///////////////////////////////////////////////////////
//@d݂Â̍l
//@PD܂d݂uPṽZ𔭌B
//@QD̃Z̎l̕ǃf[^āA
//@RDǂȂ̃Z̏d݂āA
//	SDꂪuOvŁAɁułɗƂvZłuPtOvĂB
//@TDPȏ̏d݂Zf[^SvXPB
//@UDuPtOvɊÂāAPd݂ɓBtO͗pς񂾂OɂǂB
//@VDP`UJԂAS[̏d݂PɂȂIB
///////////////////////////////////////////////////////
	if(ReadRobotCellData(7,7).Kitakaisu + ReadRobotCellData(7,8).Kitakaisu + ReadRobotCellData(8,7).Kitakaisu + ReadRobotCellData(8,8).Kitakaisu == 0)
		return;	//S[ɓBƂȂΌvZȂ
	WriteOmomiData(0,0,1);	//X^[g̏d݂Pɂ

	while(1){
		for(i = 0; i < 16; i++){
			for(j = 0; j < 16; j++){
				int weight = ReadRobotCellData(i, j).Omomi;
				if(weight == 1){
					cell tmpCell = ReadKabeData(i,j);
					if((tmpCell.NorthKabe == false) && (ReadRobotCellData(i+1,j).Kitakaisu != 0) && (ReadRobotCellData(i+1,j).Omomi < 1)){
							WriteTsugiKensa(i+1,j,1);
					}
					if((tmpCell.EastKabe == false) && (ReadRobotCellData(i,j+1).Kitakaisu != 0) && (ReadRobotCellData(i,j+1).Omomi < 1)){
							WriteTsugiKensa(i,j+1,1);
					}
					if((tmpCell.SouthKabe == false) && (ReadRobotCellData(i-1,j).Kitakaisu != 0) && (ReadRobotCellData(i-1,j).Omomi < 1)){
							WriteTsugiKensa(i-1,j,1);
					}
					if((tmpCell.WestKabe == false) && (ReadRobotCellData(i,j-1).Kitakaisu != 0) && (ReadRobotCellData(i,j-1).Omomi < 1)){
							WriteTsugiKensa(i,j-1,1);
					}
				}
			}
		}
		for(i = 0; i < 16; i++){
			for(j = 0; j < 16; j++){
				int weight = ReadRobotCellData(i, j).Omomi;
				if(weight >= 1){
					WriteOmomiData(i,j,weight + 1);
				}
			}
		}
		//ɌΏۂȂtO낷BĎ̑Ώۂ肵Ad݂1ɂB
		for(i = 0; i < 16; i++){
			for(j = 0; j < 16; j++){
				if(ReadRobotCellData(i,j).TsugiKensa == 1){
						//tO낷
						WriteTsugiKensa(i,j,0);
						//tOĂZ̏d݂Pɂ
						WriteOmomiData(i,j,1);
				}
			}
		}
		if(ReadRobotCellData(7,7).Omomi + ReadRobotCellData(7,8).Omomi + ReadRobotCellData(8,7).Omomi + ReadRobotCellData(8,8).Omomi != 0)
			break;
	}
}



//@ꏊ炠ꏊւ̍ŒZoHvZvO
//@ZiI,JjS[܂ł̍ŒZoHisƂȂꏊ͕ǂȂƂɂj߂
//
//@@̏ꍇs(0,0)X^[g(7,7)S[
//@A(7,7)X^[g(0,0)S[ƂƗǂB
//
//	@̂߂́ud݁vvZvO
//@
//@d݂Â̍l
//@܂ōsƂȂꏊ́uǂȂv̂Ƃčl̂ʂƈقȂB
//@PD܂d݂uPṽZ𔭌B
//@QD̃Z̎l̕ǃf[^āA
//@RDǂȂ̃Z̏d݂āA
//	SDꂪuOvuPtOvĂB
//@TDPȏ̏d݂Zf[^SvXPB
//@UDuPtOvɊÂāAPd݂ɓBtO͗pς񂾂OɂǂB
//@VDP`UJԂAS[̏d݂PɂȂIB
//@



void RobotMap::KeisanAdachiOmomi(int Start_I,int Start_J,int Goal_I,int Goal_J)
{
	int i,j;
	//d݃f[^
	for(i = 0; i < 16; i++){
		for(j = 0; j < 16; j++){
			WriteOmomiData(i, j, 0);
			WriteTsugiKensa(i, j, 0);
		}
	}
	WriteOmomiData(Start_I,Start_J,1);	//X^[g̏d݂Pɂ
	//ŒZoH߂邽߂́udݕtv
	while(1){
		for(i = 0; i < 16; i++){
			for(j = 0; j < 16; j++){
				int weight = ReadRobotCellData(i, j).Omomi;
				if(weight == 1){
					cell tmpCell = ReadKabeData(i,j);
					if(i < 15 && (tmpCell.NorthKabe == false) && (ReadRobotCellData(i+1,j).Omomi < 1))
							WriteTsugiKensa(i+1,j,1);
					if(j < 15 && (tmpCell.EastKabe == false) && (ReadRobotCellData(i,j+1).Omomi < 1))
							WriteTsugiKensa(i,j+1,1);
					if(i > 0 && (tmpCell.SouthKabe == false) && (ReadRobotCellData(i-1,j).Omomi < 1))
							WriteTsugiKensa(i-1,j,1);
					if(j > 0 && (tmpCell.WestKabe == false) && (ReadRobotCellData(i,j-1).Omomi < 1))
							WriteTsugiKensa(i,j-1,1);
				}
			}
		}
		//d݂1ȏ̃ZÃZ̏d݂1₷B
		for(i = 0; i < 16; i++){
			for(j = 0; j < 16; j++){
				int weight = ReadRobotCellData(i, j).Omomi;
				if(weight >= 1){
					WriteOmomiData(i,j,weight + 1);
				}
			}
		}
		//ɌΏۂȂtO낷BĎ̑Ώۂ肵Ad݂1ɂB
		for(i = 0; i < 16; i++){
			for(j = 0; j < 16; j++){
				if(ReadRobotCellData(i, j).TsugiKensa == 1){
						//tO낷
						WriteTsugiKensa(i,j,0);
						//tOĂZ̏d݂Pɂ
						WriteOmomiData(i,j,1);
				}
			}
		}
		//ړInɂǂ蒅dݕtI
		if(ReadRobotCellData(Goal_I,Goal_J).Omomi != 0)
			break;
	}
	//ŒZoȞvZ
	//l
	//ŒZoH́AS[PŁAPd݂ZȂłƂœB
	//PD܂d݁uPṽZBin_Ƃj
	//QD̗אڋŁAdP̂BiD揇ʁu쓌kvj
	//RDZȊOœd݂̃ZÃZ̏d݂͂OɂB
	//SDQRJԂB
	//TDZ[0.0]n_ɂȂƂ܂łIB

	//PDn_iS[̂d݂uPvł́j𔭌B
	if(ReadRobotCellData(Goal_I,Goal_J).Omomi != 1)
		return;
	int Shiten_I,Shiten_J;

	Shiten_I = Goal_I; 
	Shiten_J = Goal_J;
	//Q`ŠJԂ
	int weight = 0;
	while(1){
		cell tmpCell = ReadKabeData(Shiten_I,Shiten_J);
		weight ++;
		while(1){
			if(Shiten_J > 0 && Cell[Shiten_I][Shiten_J - 1].Omomi == weight && tmpCell.WestKabe == false){
				Shiten_J --;	break;
			}
			if(Shiten_I > 0 && Cell[Shiten_I - 1][Shiten_J].Omomi == weight && tmpCell.SouthKabe == false){
				Shiten_I --;	break;
			}
			if(Shiten_J < 15 && Cell[Shiten_I][Shiten_J + 1].Omomi == weight && tmpCell.EastKabe == false){
				Shiten_J ++;	break;
			}
			if(Shiten_I < 15 && Cell[Shiten_I + 1][Shiten_J].Omomi == weight && tmpCell.NorthKabe == false){
				Shiten_I ++;	break;
			}
			break;
		}
		for(i = 0;i < 16;i ++ ){
			for(j = 0;j < 16;j ++){
				if(((i != Shiten_I || j != Shiten_J) && Cell[i][j].Omomi == weight) || Cell[i][j].Omomi > Cell[Start_I][Start_J].Omomi)
					Cell[i][j].Omomi = 0;
			}
		}
		if(Shiten_I == Start_I && Shiten_J == Start_J) 
			break;
	}
}

/////////////////////////////////////////////////////////////
//d݃f[^ƂɁAŒZoH߂BŒZoHȊÓud݁v0ɂB
/////////////////////////////////////////////////////////////

void RobotMap::KeisanSaitan(void)	
{
	//l
	//ŒZoH́AS[PŁAPd݂ZȂłƂœB
	//PD܂d݁uPṽZBin_Ƃj
	//QD̗אڋŁAdP̂BiD揇ʁu쓌kvj
	//RDZȊOœd݂̃ZÃZ̏d݂͂OɂB
	//SDQRJԂB
	//TDZ[0.0]n_ɂȂƂ܂łIB
	int i,j,I,J,weight;

	//PDn_iS[̂d݂uPvł́j𔭌B
	if(ReadRobotCellData(7,7).Omomi != 1 && ReadRobotCellData(7,8).Omomi != 1 && ReadRobotCellData(8,7).Omomi != 1 && ReadRobotCellData(8,8).Omomi != 1)
		return;
	while(1){
		if(ReadRobotCellData(7,7).Omomi == 1) {
			I = 7; J = 7; break;
		}
		if(ReadRobotCellData(7,8).Omomi == 1) {
			I = 7; J = 8; break;
		}
		if(ReadRobotCellData(8,7).Omomi == 1) {
			I = 8; J = 7; break;
		}
		if(ReadRobotCellData(8,8).Omomi == 1) {
			I = 8; J = 8; break;
		}
		break;
	}

	//Q`ŠJԂ
	weight = 0;
	while(1){
		cell tmpCell = ReadKabeData(I,J);
		weight ++;
		while(1){
			if(J > 0 && Cell[I][J - 1].Omomi == weight && tmpCell.WestKabe == false){
				J --;	break;
			}
			if(I > 0 && Cell[I - 1][J].Omomi == weight && tmpCell.SouthKabe == false){
				I --;	break;
			}
			if(J < 15 && Cell[I][J + 1].Omomi == weight && tmpCell.EastKabe == false){
				J ++;	break;
			}
			if(I < 15 && Cell[I + 1][J].Omomi == weight && tmpCell.NorthKabe == false){
				I ++;	break;
			}
			break;
		}
		for(i = 0;i < 16;i ++ ){
			for(j = 0;j < 16;j ++){
				if((i != I || j != J) && Cell[i][j].Omomi == weight)
					Cell[i][j].Omomi = 0;
			}
		}

		if(I == 0 && J == 0) 
			break;
	}
}
/////////////////////////////////////////////////////////////
//@ɊÂĂn_炠n_܂ł̍ŒZoH߁AƂ
//ŒZoHn}쐬BieZɂ͊en_ōsׂsiOiAE܁A܁A^[jĂj
/////////////////////////////////////////////////////////////

void RobotMap::SakuseiAdachiMap(int Start_I,int Start_J,int Goal_I,int Goal_J,int GenzaiMuki)
{
	int i,j,weight;
	int Shiten_I,Shiten_J;
	//d݃f[^
	for(i = 0; i < 16; i++){
		for(j = 0; j < 16; j++){
			WriteOmomiData(i, j, 0);
			WriteTsugiKensa(i, j, 0);
			WriteSaitanMapData(i, j, 0);
		}
	}
	WriteOmomiData(Start_I,Start_J,1);	//X^[g̏d݂Pɂ
	//ŒZoH߂邽߂́udݕtv
	while(1){
		for(i = 0; i < 16; i++){
			for(j = 0; j < 16; j++){
				weight = ReadRobotCellData(i, j).Omomi;
				//d݂1ȏ̃ZÃZ̏d݂1₷B
				if(weight >= 1)
					WriteOmomiData(i,j,weight + 1);
				if(weight == 1){
					cell tmpCell = ReadKabeData(i,j);
					if(i < 15 && (tmpCell.NorthKabe == false) && (ReadRobotCellData(i+1,j).Omomi < 1))
							WriteTsugiKensa(i+1,j,1);
					if(j < 15 && (tmpCell.EastKabe == false) && (ReadRobotCellData(i,j+1).Omomi < 1))
							WriteTsugiKensa(i,j+1,1);
					if(i > 0 && (tmpCell.SouthKabe == false) && (ReadRobotCellData(i-1,j).Omomi < 1))
							WriteTsugiKensa(i-1,j,1);
					if(j > 0 && (tmpCell.WestKabe == false) && (ReadRobotCellData(i,j-1).Omomi < 1))
							WriteTsugiKensa(i,j-1,1);
				}
			}
		}
		//ɌΏۂȂtO낷BĎ̑Ώۂ肵Ad݂1ɂB
		for(i = 0; i < 16; i++){
			for(j = 0; j < 16; j++){
				if(ReadRobotCellData(i, j).TsugiKensa == 1){
						//tO낷
						WriteTsugiKensa(i,j,0);
						//tOĂZ̏d݂Pɂ
						WriteOmomiData(i,j,1);
				}
			}
		}
		//ړInɂǂ蒅dݕtI
		if(ReadRobotCellData(Goal_I,Goal_J).Omomi != 0)
			break;
	}
	//ŒZoȞvZ
	//l
	//ŒZoH́AS[PŁAPd݂ZȂłƂœB
	//PD܂d݁uPṽZBin_Ƃj
	//QD̗אڋŁAdP̂BiD揇ʁu쓌kvj
	//ZȊOœd݂̃ZÃZ͖B
	//SDQRJԂB
	//TDZ[0.0]n_ɂȂƂ܂łIB

	//PDn_iS[̂d݂uPvł́j𔭌B
	if(ReadRobotCellData(Goal_I,Goal_J).Omomi != 1)
		return;
	Shiten_I = Goal_I; 
	Shiten_J = Goal_J;
	//Q`ŠJԂ
	weight = 0;
	while(1){
		cell tmpCell = ReadKabeData(Shiten_I,Shiten_J);
		weight ++;
		while(1){
			if(Shiten_J > 0 && Cell[Shiten_I][Shiten_J - 1].Omomi == weight && tmpCell.WestKabe == false){
				Shiten_J --;	break;
			}
			if(Shiten_I > 0 && Cell[Shiten_I - 1][Shiten_J].Omomi == weight && tmpCell.SouthKabe == false){
				Shiten_I --;	break;
			}
			if(Shiten_J < 15 && Cell[Shiten_I][Shiten_J + 1].Omomi == weight && tmpCell.EastKabe == false){
				Shiten_J ++;	break;
			}
			if(Shiten_I < 15 && Cell[Shiten_I + 1][Shiten_J].Omomi == weight && tmpCell.NorthKabe == false){
				Shiten_I ++;	break;
			}
			break;
		}
		for(i = 0;i < 16;i ++ ){
			for(j = 0;j < 16;j ++){
				if(((i != Shiten_I || j != Shiten_J) && Cell[i][j].Omomi == weight) || Cell[i][j].Omomi > Cell[Start_I][Start_J].Omomi)
					Cell[i][j].Omomi = 0;
			}
		}
		if(Shiten_I == Start_I && Shiten_J == Start_J) 
			break;
	}
	//ŒZoH܂̂ŁAx͂eZ̍Wɂ}EX̓ɕϊB
	//X^[g
	//Shiten_I = Start_I;
	//Shiten_J = Start_J;
	int tmpMuki = GenzaiMuki;

	//OiF0AE܁F1A^[F2A܁F3
	//NAEASAW͂ꂼ0A1A2A3Ƃł邩AƂׂs͊ȒPȌvZœB

	while(1){
		int TsugiCellOmomi = Cell[Shiten_I][Shiten_J].Omomi - 1;

		if(Shiten_I < 15 && Cell[Shiten_I + 1][Shiten_J].Omomi == TsugiCellOmomi){
			Cell[Shiten_I][Shiten_J].SaitanMap = (4 - tmpMuki) % 4;
			Shiten_I ++;
			tmpMuki = N;
		}
		else if(Shiten_J < 15 && Cell[Shiten_I][Shiten_J + 1].Omomi == TsugiCellOmomi){
			Cell[Shiten_I][Shiten_J].SaitanMap = (5 - tmpMuki) % 4;
			Shiten_J ++;
			tmpMuki = E;
		}
		else if(Shiten_I > 0 && Cell[Shiten_I - 1][Shiten_J].Omomi == TsugiCellOmomi){
			Cell[Shiten_I][Shiten_J].SaitanMap = (6 - tmpMuki) % 4;
			Shiten_I --;
			tmpMuki = S;
		}
		else if(Shiten_J > 0 && Cell[Shiten_I][Shiten_J - 1].Omomi == TsugiCellOmomi){
			Cell[Shiten_I][Shiten_J].SaitanMap = (7 - tmpMuki) % 4;
			Shiten_J--;
			tmpMuki = W;
		}
		else ;

		if(Shiten_I == Goal_I && Shiten_J == Goal_J)
			break;
	}
}
///////////////////////////////////////////////
//ŒZ}bvf[^
///////////////////////////////////////////////
void RobotMap::WriteSaitanMapData(int i, int j, int data)
{
		Cell[i][j].SaitanMap = data;
}